apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ s3_exporter_name }}
  name: {{ s3_exporter_name }}
  namespace: {{ namespace }}
spec:
  replicas: 1
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ s3_exporter_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ s3_exporter_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ s3_exporter_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
      automountServiceAccountToken: false
      containers:
      - env:
        - name: LOG_LEVEL
{% if do_debugs %}
          value: debug
{% else %}
          value: info
{% endif %}
        - name: LISTEN_PORT
          value: ":9113"
        - name: S3_ACCESS_KEY
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ s3_secret_name }}
        - name: S3_NAME
          value: {{ s3_secret_name }}
        - name: S3_BUCKET
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ s3_secret_name }}
        - name: S3_DISABLE_SSL
{% if s3_address is match('https') %}
          value: "false"
{% else %}
          value: "true"
{% endif %}
        - name: S3_ENDPOINT
          value: {{ s3_address }}
        - name: S3_FORCE_PATH_STYLE
{% if s3_address is match('amazon') %}
          value: "false"
{% else %}
          value: "true"
{% endif %}
        - name: S3_REGION
          valueFrom:
            secretKeyRef:
              key: region
              name: {{ s3_secret_name }}
        - name: S3_SECRET_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ s3_secret_name }}
{% if do_triggers == False or (opsimages | json_query("[?name=='s3exporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='s3exporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 60
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 15
          tcpSocket:
            port: 9113
          timeoutSeconds: 3
        name: s3exporter
        ports:
        - containerPort: 9113
        readinessProbe:
          initialDelaySeconds: 15
          tcpSocket:
            port: 9113
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ s3exporter_cpu_limit }}"
            memory: "{{ s3exporter_memory_limit }}"
          requests:
            cpu: "{{ s3exporter_cpu_request }}"
            memory: "{{ s3exporter_memory_request }}"
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 60
          initialDelaySeconds: 15
          tcpSocket:
            port: 9113
          timeoutSeconds: 3
{% endif %}
        volumeMounts:
        - mountPath: /tmp
          name: tmp
        workingDir: /tmp
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-monitoring
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
      securityContext:
        runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
      volumes:
      - emptyDir: {}
        name: tmp
{% if (do_triggers | default(False)) %}
  triggers:
{% if (opsimages | json_query("[?name=='s3exporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - s3exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='s3exporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
